#include <windows.h>
#include <direct.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <commctrl.h>
#include <shlobj.h>

#include "LogEvent.h"

//-------------------------------------------------------
// szPath mora biti normalizovan
BOOL CreateCompleteDir(HWND hDlg, char *szCreatePath, BOOL bCopy, const BOOL bAsk)
{
	char szPath[_MAX_PATH],
		szExist[_MAX_PATH],
		*p;
	BOOL ret= TRUE,
		bSave= TRUE,
		bCreate= FALSE;
	size_t stLen;

	// nema direktorijuma
	if(bAsk) {
		ret= MessageBox(hDlg, "Create folder?", "LogEvent", MB_ICONQUESTION|MB_YESNO);
		if(ret == IDYES)
			bCreate= TRUE;
		else
			ret= PATH_NOT_EXIST;
	} else
		bCreate= TRUE;

	if(bCreate) {
		strcpy(szPath, szCreatePath);
		stLen= strlen(szPath);
		if(szPath[stLen-1] == '\\')
			szPath[stLen-1]= '\0';
		if(stLen < 4)
			return(FALSE);
		if(szPath[0] == '\\' && szPath[1] == '\\')			// UNC
			p= &szPath[2];
		else
			p= szPath;
		p= strchr(p, '\\');		// x:/
		for(;;) {
			p= strchr(p+1, '\\');
			if(p) *p= '\0';
			if(bSave)
				if(SetCurrentDirectory(szPath)) {
					strcpy(szExist, szPath);
					if(p) *p= '\\';
					continue;
				}
			bSave= FALSE;
			if(!CreateDirectory(szPath, NULL)) {
				ret= FALSE;
				break;
			}
			if(p) *p= '\\';
		   else break;
		}
		if(!ret) {
			for(;;) {
				if(!strcmp(szExist, szPath))
					break;
				p= strrchr(szPath, '\\');
				if(!p)
					break;
				*p= '\0';
				RemoveDirectory(szPath);
			}
		}
		if(ret && bCopy)
			strcpy(szCreatePath, szPath);

		if(ret)
			ret= PATH_EXIST;
		else {
			MessageBox(hDlg, "Cannot create folder.", "LogEvent", MB_ICONEXCLAMATION|MB_OK);
			ret= ERROR_IN_PATH;
		}
	}
	
	return(ret);
}


//-------------------------------------------------------
// bCreate - da li da pita i kreira ako ga nema
int DoesDirectoryExist(HWND hDlg, const char *szPathChk)
{
	int ret;
	char szCurPath[_MAX_PATH];
	char *szPathNormal;		// normalizovana putanja
	char *p;

//	char drive[_MAX_DRIVE];
//	char dir[_MAX_DIR];
//	char fname[_MAX_FNAME];
//	char ext[_MAX_EXT];

	p= szPathNormal= _fullpath(NULL, szPathChk, 0);
	if(!szPathNormal)
		return(ERROR_IN_PATH);
//	_splitpath(szPathNormal, drive, dir, fname, ext);

	GetCurrentDirectory(sizeof(szCurPath), szCurPath);

	if(!SetCurrentDirectory(szPathNormal))
		ret= PATH_NOT_EXIST;
	else
		ret= PATH_EXIST;

	SetCurrentDirectory(szCurPath);
	if(szPathNormal)
		free(szPathNormal);
	return(ret);
}

//-------------------------------------------------------
// funkcija za izbor dira preko browse tastera
int GetFolder(HWND hDlg, char *szPath)
{
	BROWSEINFO bi;
	LPITEMIDLIST pidlBrowse, pidlRoot;
	LPMALLOC g_pMalloc;		// potrebno za Shell's Namespace
	int ret;

	ret= 1;
	if (!SUCCEEDED(SHGetMalloc(&g_pMalloc)))
		return(ret);	// kasnije moda neka poruka o greci?
	if (!SUCCEEDED(SHGetSpecialFolderLocation(hDlg, CSIDL_DRIVES, &pidlRoot)))
		return(ret);
	bi.hwndOwner= hDlg;
	bi.pidlRoot= pidlRoot;
	bi.pszDisplayName= szPath;
	bi.lpszTitle= NULL; // "Izaberi folder";
	bi.ulFlags= BIF_DONTGOBELOWDOMAIN|BIF_RETURNONLYFSDIRS;
	bi.lpfn= (BFFCALLBACK)NULL;
	bi.lParam= 0;
	bi.iImage= 0;
	pidlBrowse= SHBrowseForFolder(&bi);
	if(pidlBrowse != NULL) {
		if(SHGetPathFromIDList(pidlBrowse, szPath))
			ret= 0;
		// istimo resurse, na nov nain
		g_pMalloc->lpVtbl->Free(g_pMalloc, pidlBrowse);
	}
	// i ovo za kraj
	g_pMalloc->lpVtbl->Release(g_pMalloc);
	return(ret);
}


//-------------------------------------------------------
// browse funkcija za izbor programa
int GetProgram(HWND hDlg, char *szFile)
{
	OPENFILENAME OpenFileName;
	int ret= 1;
	char szExt[256];
	char *p;

	OpenFileName.lStructSize       = sizeof(OPENFILENAME); 
	OpenFileName.hwndOwner         = hDlg; 
	OpenFileName.hInstance         = (HANDLE)hInstance; 
	OpenFileName.lpstrFilter       = "Program Files (*.exe;*.com)\0*.EXE;*.COM;*.PIF\0"
							   "Batch Files (*.bat)\0*.BAT\0"
							   "Shortcut (*.lnk)\0*.LNK\0"
							   "\0\0"; 
	OpenFileName.lpstrCustomFilter = (LPTSTR)NULL; 
	OpenFileName.nMaxCustFilter    = 0L;

	p= ".EXE";
	if(strlen(szFile)) {
		char *k;
		k= strrchr(szFile, '.');
		if(k)
			p= k;
	}
	sprintf(szExt, "*%s", p);
	_strlwr(szExt);
	if(!strcmp(p, "*.bat"))
		OpenFileName.nFilterIndex      = 2L;
	else if(!strcmp(p, "*.lnk"))
		OpenFileName.nFilterIndex      = 4L;
	else
		OpenFileName.nFilterIndex      = 1L;

	OpenFileName.nFilterIndex      = 2L;
	OpenFileName.lpstrFile         = szFile;
	OpenFileName.nMaxFile          = MAX_PATH;
	OpenFileName.lpstrFileTitle    = NULL;
	OpenFileName.nMaxFileTitle     = 0;
	OpenFileName.lpstrInitialDir   = NULL;
	OpenFileName.lpstrTitle        = "Choose a Program";
	OpenFileName.nFileOffset       = 0;
	OpenFileName.nFileExtension    = 0;
	OpenFileName.lpstrDefExt       = "exe";
	OpenFileName.lCustData         = 0;
	OpenFileName.Flags             =	OFN_EXPLORER | 
								OFN_PATHMUSTEXIST | 
								OFN_FILEMUSTEXIST | 
								OFN_NONETWORKBUTTON |
								OFN_HIDEREADONLY; 

	if(GetOpenFileName(&OpenFileName)) {
		strcpy(szFile, OpenFileName.lpstrFile);
		ret= 0;
	} // else
	 // MessageBox(hDlg, "File not found.", NULL, MB_OK);

    return(ret);
}
