// mjova 2/7/96

#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <stdlib.h>
#include <direct.h>
#include <commctrl.h>
#include <shlobj.h>


#include "..\logEvent.h"
#include "LogStat.h"


HFONT hFont;
HANDLE hDllInst;
DAILY dSum[24];
HWND hData;
int i;
char szFirst[128];
HWND hStatsDlg= 0;
int iLogonCnt,
	iPowerOn,
	iDaysOnRun;


//-------------------------------------------------------
BOOL CALLBACK eStatistics(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg) {
		case WM_INITDIALOG: {
			int iMax= 0;
			char szBuf[512];
			int iWndW= 340,
				iWndH= 398+120;
			int iCapH,
				iFrmW,
				iFrmH;
			HWND hButton;
			RECT Rect;

			SetWindowPos(hDlg, HWND_TOP, 100, 100, iWndW, iWndH, 0);
			hButton= GetDlgItem(hDlg, IDOK);
			GetWindowRect(hButton, &Rect);
			iCapH= GetSystemMetrics(SM_CYCAPTION);
			iFrmW= GetSystemMetrics(SM_CXSIZEFRAME);
			iFrmH= GetSystemMetrics(SM_CYSIZEFRAME);
			SetWindowPos(hButton, HWND_TOP, iWndW-(Rect.right-Rect.left)-7-iFrmW*2, 
													  iWndH-(Rect.bottom-Rect.top)-7-iFrmH*2-iCapH, 0, 0, SWP_NOSIZE);

			hFont= GetStockObject(DEFAULT_GUI_FONT);
			for(i= 0; i<24; i++) {
				iMax= max(dSum[i].iMinutes, 0);
				// mada niko ne garantuje da e izraz IDC_PROGRESS0+i biti
				// ok posle nekog editovanja dijaloga, ovako je lake...

				dSum[i].hwndLineNo= CreateWindow("static",
											(LPSTR) NULL, WS_CHILD | WS_VISIBLE | SS_RIGHT,
											7, 7+i*(PROGRESS_H+1),	// x, y 
											20, PROGRESS_H,			// w h
											hDlg, (HMENU)0, hDllInst, NULL);
				SendMessage(dSum[i].hwndLineNo, WM_SETFONT, (WPARAM)hFont, 0);

				dSum[i].hwndProgess= CreateWindowEx(0, PROGRESS_CLASS, 
											(LPSTR) NULL, WS_CHILD | WS_VISIBLE, 
											30, 7+i*(PROGRESS_H+1),	// x, y
											250, PROGRESS_H,			// W, H
											hDlg, (HMENU)0, hDllInst, NULL); 
				SendMessage(dSum[i].hwndProgess, PBM_SETRANGE, 0, MAKELPARAM(0, MAX_PROGRESS));

				dSum[i].hwndValue= CreateWindow("static",
											(LPSTR) NULL, WS_CHILD | WS_VISIBLE | SS_RIGHT,
											283, 7+i*(PROGRESS_H+1),	// x, y 
											40, PROGRESS_H,				// w h
											hDlg, (HMENU)0, hDllInst, NULL);
				SendMessage(dSum[i].hwndValue, WM_SETFONT, (WPARAM)hFont, 0);
			}
			
			for(i= 0; i<24; i++) {
				SendMessage(dSum[i].hwndProgess, PBM_SETPOS, (WPARAM) dSum[i].iMinutes*MAX_PROGRESS/iMax, 0);
				sprintf(szBuf, "%i", i);
				SendMessage(dSum[i].hwndLineNo, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)szBuf);
				sprintf(szBuf, "%i:%02i", dSum[i].iMinutes/60, dSum[i].iMinutes%60);
				SendMessage(dSum[i].hwndValue, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)szBuf);
			}

			hData= CreateWindow("static",
										(LPSTR) NULL, WS_CHILD | WS_VISIBLE,
										30, 17+24*(PROGRESS_H+1),		// x, y 
										250, 3*PROGRESS_H,				// w h
										hDlg, (HMENU)0, hDllInst, NULL);
			SendMessage(hData, WM_SETFONT, (WPARAM)hFont, 0);
			sprintf(szBuf, "Started %s, days on run %i\n"
								"On/Off %i, PowerOn (h:mm) %i:%02i\n"
								"Daily - On/Off: %i.%i, PowerOn %i:%02i", 
										szFirst, iDaysOnRun,
										iLogonCnt, iPowerOn/60, iPowerOn%60,
										(iLogonCnt/iDaysOnRun), (iLogonCnt*100/iDaysOnRun)%100, 
													iPowerOn/iDaysOnRun/60, (iPowerOn/iDaysOnRun)%60);
			SendMessage(hData, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)szBuf);

			hStatsDlg= hDlg;
			}
			break;

		case WM_COMMAND:
			switch(GET_WM_COMMAND_ID(wParam, lParam)) {
				case IDOK:
					ShowWindow(hDlg, SW_HIDE);
					for(i= 0; i<24; i++) {
						DestroyWindow(dSum[i].hwndProgess);
						DestroyWindow(dSum[i].hwndLineNo);
						DestroyWindow(dSum[i].hwndValue);
					}
					DeleteObject(hFont);
					hStatsDlg= 0;
					EndDialog(hDlg, 0);
					break;
			}
			break;

		default:
			return (FALSE);
	}
	return(TRUE);
}

//-------------------------------------------------------
DllExport void Statistics(HWND hWnd, PROPERTIES propCfg)
{
	char szBuf[256];
	FILE *fLog;
	int iHH, iMM, iMin;
	int iWorking;

	if(hStatsDlg) {
		ShowWindow(hStatsDlg, SW_SHOW);
		return;
	}

	sprintf(szBuf, "%s\\" STATFILENAME, propCfg.szDataDir);
	fLog= fopen(szBuf, "rt");
	if(!fLog) {
		MessageBox(hWnd, "Stat file does not exist.\nAfter 3rd shut down, stats will work...", 
								"LogEvent", MB_ICONEXCLAMATION|MB_OK);
		return;
	}

	memset(dSum, 0, sizeof(dSum));
	iWorking= iLogonCnt=0;
	while(!feof(fLog)) {
		// dd/MM/yyyy ddd HH:mm 000:00:00\r\n
		// 012345678901234567890123456789012
		fgets(szBuf, sizeof(szBuf), fLog);
		if(strlen(szBuf) != 31)
			continue;
		if(!szFirst[0])
			strcpy(szFirst, szBuf);
		iHH= atoi(&szBuf[15]);
		if(iHH>23)	continue;
		iMM= atoi(&szBuf[18]);
		if(iMM>59)	continue;
		iMin= atoi(&szBuf[21])*60;
		iMin+= atoi(&szBuf[25]);
//		iMin+= atoi(&szBuf[28]);
		iWorking+= iMin;
		iLogonCnt++;

		while(iMin) {
			if(iMin<(60-iMM)) {
				dSum[iHH].iMinutes+= iMin;
				break;		// iMin= 0;
			} else {
				dSum[iHH].iMinutes+= 60-iMM;
				iMin-= 60-iMM;
				iMM= 0;
				iHH++;
				iHH%= 24;
			}
		}
	}

	fclose(fLog);

	if(iLogonCnt < 3) {
		MessageBox(hWnd, "Not enough entries for good statistics.", "LogEvent", MB_ICONINFORMATION|MB_OK);
		return;
	}

	{
		char *p;
		struct tm tmFirst;
		time_t tFirst, tNow, tTemp;

		memset(&tmFirst, 0, sizeof(tmFirst));
		iDaysOnRun= iPowerOn= 0;
		for(i= 0; i<24; i++)
			iPowerOn+= dSum[i].iMinutes;
		if(*szFirst) {
			szFirst[10]= 0;
			p= szFirst;
			if(*p == ' ') p++;
			tmFirst.tm_mday= atoi(p);
			p= szFirst+3;
			if(*p == ' ') p++;
			tmFirst.tm_mon= atoi(p)-1;
			p= szFirst+6;
			tmFirst.tm_year= atoi(p)-1900;
			tFirst= mktime(&tmFirst);
			time(&tNow);
			tTemp= tNow - tFirst;
			if(tTemp>0)
				iDaysOnRun= tTemp/60/60/24;
		}
	}


	DialogBox(hDllInst, MAKEINTRESOURCE(IDD_STATISTICS), hWnd, eStatistics);

}

//-------------------------------------------------------
BOOL WINAPI DllMain(HANDLE hInst, ULONG ul_reason_for_call, LPVOID lpReserved) {

	hDllInst= hInst;

	return(TRUE);
}
  



