// mjova, 26/4/96

#include <windowsx.h>
#include <windows.h>
#include <stdio.h>
#include <time.h>
#include <commctrl.h>

#include "resource.h"
#include "LogEvent.h"


// DllImport void Statistics(HWND hwndMain);

//-------------------------------------------------------
BOOL TrayIcon(DWORD dwMessage)
{
	BOOL ret= 0;
	NOTIFYICONDATA nid;
	DWORD dwCurTicks;
	int iH, iM; //, iS;
	static char szOldTip[64];
	static BOOL fTaskbarIcon= FALSE;	// da li je ikonica vidljiva?
	clock_t ctCur;

	ctCur= clock();

	if(dwMessage == NIM_ADD)
		szOldTip[0]= 0;

	nid.cbSize= sizeof(NOTIFYICONDATA);
	nid.hWnd= hwndMainDialog;		// imamo sam jednu ikonicu...
	nid.uID= 0;
	nid.uFlags= NIF_TIP | NIF_MESSAGE | NIF_ICON;
	nid.uCallbackMessage= TRAY_MSG_NOTIFYICON;
	nid.hIcon= LoadIcon(hInstance,MAKEINTRESOURCE(IDI_TRAY));

	dwCurTicks= dwRunning + (ctCur-ctStart)/CLOCKS_PER_SEC;
	// iS= dwCurTicks%60;
	iM= (dwCurTicks/60)%60;
	iH= (dwCurTicks/60)/60;
	sprintf(nid.szTip, "Running: %03i:%02i  ", iH, iM);
	if(!*szOldTip)
		strcpy(szOldTip, nid.szTip);
	switch(dwMessage) {
		case NIM_ADD:
			if(!fTaskbarIcon) {
				ret= Shell_NotifyIcon(dwMessage, &nid);
				fTaskbarIcon= TRUE;
			}
			break;
		case NIM_MODIFY:
			if(!strcmp(szOldTip, nid.szTip))
				break;
			strcpy(szOldTip, nid.szTip);
			ret= Shell_NotifyIcon(dwMessage, &nid);
			break;
		case NIM_DELETE:
			if(fTaskbarIcon) {
				ret= Shell_NotifyIcon(dwMessage, &nid);
				fTaskbarIcon= FALSE;
			}
			break;
	}
	if(nid.hIcon)
		DestroyIcon(nid.hIcon);
	return(ret);	
}

//-------------------------------------------------------
void TrayMenu(HWND hDlg)
{
	POINT pPoint;
	HMENU hMenu;
	HBITMAP hBitmap;

	GetCursorPos(&pPoint);
	hMenu= CreatePopupMenu();
	AppendMenu(hMenu, MF_STRING, ID_OPENDIALOG, "&Open");
	AppendMenu(hMenu, MF_STRING, ID_STATISTICS, "&Statistics");
	AppendMenu(hMenu, MF_SEPARATOR, (UINT)NULL, (UINT)NULL);
	AppendMenu(hMenu, MF_STRING, ID_ABOUT, "&About");
	hBitmap= LoadBitmap(hInstance, MAKEINTRESOURCE(IDB_PROP));
	AppendMenu(hMenu, MF_BITMAP, ID_PROP, hBitmap);
	AppendMenu(hMenu, MF_STRING, ID_EXIT, "&Exit");
	SetMenuDefaultItem(hMenu, ID_OPENDIALOG, FALSE);	

	SetForegroundWindow(hDlg);
	TrackPopupMenu(hMenu, 0, pPoint.x, pPoint.y, 0, hDlg, NULL);
	PostMessage(hDlg, WM_USER, 0, 0);
	DestroyMenu(hMenu);
}

//-------------------------------------------------------
BOOL CALLBACK eLogEvent(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
		case WM_INITDIALOG:
			// podeavamo globalnu (r/w shared) promenljivu
			hwndMainDialog= hDlg;
			// inicijalno properties dijalog nije prikazan
			hwndPropDlg= NULL;	
			// itamo podatke sa diska
			if(LoadCfg(&propCfg)) {

				MakeDefaultCfg(&propCfg);
				PropertiesLogEvent(hDlg);
				SaveCfg(&propCfg);
			}
			memcpy(&propOrg, &propCfg, sizeof(propCfg));
			SetWindowPos(hDlg, HWND_BOTTOM, propCfg.lX, propCfg.lY, 0, 0, SWP_NOSIZE|SWP_HIDEWINDOW);
			// podesi stanje checkbox-a i TrayIcon
			if(propCfg.fTrayIcon)		
				TrayIcon(NIM_ADD);		
			SendDlgItemMessage(hDlg, IDC_TRAYICON, BM_SETCHECK, propCfg.fTrayIcon, 0);
			{
				// sistemski meni za prozor
				HMENU hControlMenu;
				HBITMAP hBitmap;

				hControlMenu= GetSystemMenu(hDlg, FALSE);
				AppendMenu(hControlMenu, MF_SEPARATOR, (UINT)NULL, (UINT)NULL);
				AppendMenu(hControlMenu, MF_STRING, IDM_SC_STATISTICS, "&Statistics");
				AppendMenu(hControlMenu, MF_SEPARATOR, (UINT)NULL, (UINT)NULL);
				hBitmap= LoadBitmap(hInstance, MAKEINTRESOURCE(IDB_PROP));
				AppendMenu(hControlMenu, MF_BITMAP, IDM_SC_PROP, hBitmap);
				AppendMenu(hControlMenu, MF_STRING, IDM_SC_ABOUT, "&About");
			}
			{
				// dijalog inicijalno nema ikonice.
				// postavimo ikonu da bi postao "pravi prozor"
				HICON hIcon;

				hIcon= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON));
				SendMessage(hDlg, WM_SETICON, (WPARAM)(BOOL)FALSE, (LPARAM)(HICON)hIcon);
				SendMessage(hDlg, WM_SETICON, (WPARAM)(BOOL)TRUE, (LPARAM)(HICON)hIcon);
			}
			return(TRUE);

		case WM_INITMENU: {
				HMENU hControlMenu;

				hControlMenu= GetSystemMenu(hDlg, FALSE);
				EnableMenuItem(hControlMenu, SC_MAXIMIZE, MF_BYCOMMAND|MF_GRAYED);
				EnableMenuItem(hControlMenu, SC_SIZE, MF_BYCOMMAND|MF_GRAYED);
				SetMenuDefaultItem(hControlMenu, SC_MINIMIZE, FALSE);
			}
			return(TRUE);

		case WM_MOVE: {
				RECT rect;

				GetWindowRect(hDlg, &rect);
				propCfg.lX= rect.left;
				propCfg.lY= rect.top;
			}
			return(FALSE);	// POMERANJE PROZORA NEKA OBAVI WIN

		// sistemski meni (desni taster na imenu)
		case WM_SYSCOMMAND:
			switch (wParam&0xFFF0) {
				case SC_CLOSE:
					SendMessage(hDlg, WM_COMMAND, ID_EXIT, 0);
					break;
				case IDM_SC_ABOUT:
					SendMessage(hDlg, WM_COMMAND, ID_ABOUT, 0);
					break;
				case IDM_SC_PROP:
					SendMessage(hDlg, WM_COMMAND, ID_PROP, 0);
					break;
				case SC_MINIMIZE:
					SendMessage(hDlg, WM_COMMAND, ID_MINIMIZE, 0);
					break;
				case IDM_SC_STATISTICS:
					SendMessage(hDlg, WM_COMMAND, ID_STATISTICS, 0);
					break;
				default:
					return(FALSE);
			}
			return(TRUE);

		// default opcija, minimize
		case WM_NCLBUTTONDBLCLK:
			if(wParam == HTCAPTION) {
				SendMessage(hDlg, WM_SYSCOMMAND, SC_MINIMIZE, 0);
				return(TRUE);
			}
			return(FALSE);		// ostale HT neka procesira win

		// komande zadate preko ikone taskbar-a
 		case TRAY_MSG_NOTIFYICON:
 			switch (lParam) {
				case WM_MOUSEMOVE: 
					TrayIcon(NIM_MODIFY);
					break;
 				case WM_RBUTTONDOWN:
					if(hwndPropDlg) {
						SetForegroundWindow(hwndPropDlg);
						break;
					}
					if(IsWindowVisible(hDlg)) {
						SetForegroundWindow(hDlg);
						break;
					}
					TrayMenu(hDlg);
  					break;
				case WM_LBUTTONDBLCLK:
					SendMessage(hDlg, LOGE_MSG_OPENDIALOG, 0, 0);
					break;
				default:
					return(FALSE);
 			}
 			return(TRUE);

		// prikazivanje skrivenog prozora.
		case LOGE_MSG_OPENDIALOG:
			if(hwndPropDlg) {
				SetForegroundWindow(hwndPropDlg);
				return(TRUE);
			}
			if(!IsWindowVisible(hDlg)) {
				ShowWindow(hDlg, SW_SHOW);
				ShowWindow(hDlg, SW_RESTORE);
			}
			SetForegroundWindow(hDlg);
			return(TRUE);

		case WM_COMMAND:
			switch(GET_WM_COMMAND_ID(wParam, lParam)) {
				case ID_EXIT:
					CheckProperty(hDlg);
					DestroyWindow(hDlg);
					break;
				case ID_MINIMIZE:
					CheckProperty(hDlg);
					ShowWindow(hDlg, SW_MINIMIZE);
					ShowWindow(hDlg, SW_HIDE);
					break;
				case ID_OPENDIALOG:
					ShowWindow(hDlg, SW_SHOW);
					ShowWindow(hDlg, SW_RESTORE);
					break;
				case ID_ABOUT:
					AboutLogEvent(hDlg);
					break;
				case IDC_TRAYICON:
					if(BST_CHECKED == SendDlgItemMessage(hDlg, IDC_TRAYICON, BM_GETCHECK, 0, 0)) {
						propCfg.fTrayIcon= TRUE;
						TrayIcon(NIM_ADD);
					} else {
						propCfg.fTrayIcon= FALSE;
						TrayIcon(NIM_DELETE);
					}
					break;
				case ID_PROP:		// ovo dolazi od tastera 
					PropertiesLogEvent(hDlg);
					break;
				case ID_STATISTICS:
					Statistics(hDlg, propCfg);
					break;
				default:
					return(FALSE);
 			}
 			return(TRUE);
									  
		case WM_ENDSESSION:
			SaveLogout(hDlg);
			return(TRUE);

		case WM_DESTROY:
			SaveLogout(hDlg);
			if(propCfg.fTrayIcon)
				TrayIcon(NIM_DELETE);
			PostQuitMessage(0);
			return(TRUE);

	}
	return(FALSE);
}

//---------------------------------------------------------------------------
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) {
	HWND hwnd, hwndLast;
	MSG msg;
	HACCEL hAccelerator;

	if(hwndMainDialog) {
		// ako je ve startovan program, otvori dijalog
		SendMessage(hwndMainDialog, LOGE_MSG_OPENDIALOG, 0, 0);
		return(0);
	}

	// podeavamo startno vreme. mogue je koristiti i 
	// funkciju GetTickCount(), ali njome se dobija vreme
	// od poetka rada win, a ne od startovanja programa.
	ctStart= clock();

	InitCommonControls();

	// posle startovanja vratiemo aktivan prozor
	hwndLast= GetForegroundWindow();
	
	// =====================
	// set global vars
	// =====================
	// current instance, podatak nema previe znaaja, osim to je 
	// nepohodan argument izvesnom broju funkcija. ;)
	hInstance= hInst;	

	hwnd= CreateDialog(hInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, eLogEvent);

	// snimamo poetak rada...
	while(SaveStartTime(hwnd)) {
		int ret;

		ret= MessageBox(hwnd, "Set property?", "LogEvent - Error in property!", 
									MB_ICONQUESTION|MB_YESNO);
		if(ret == IDYES) {
			// nije snimljeno jer postoji problem sa putanjom...
			// aljemo poruku da odmah startuje properties
			SendMessage(hwnd, WM_COMMAND, ID_PROP, 0);
		} else {
			ret= MessageBox(hwnd, "Exit?", "LogEvent - Error in property!", 
									MB_ICONQUESTION|MB_YESNO);
			if(ret == IDYES)
				return(0);
		}
	}

	// vratimo fokus na prethodni prozor..
	SetForegroundWindow(hwndLast);

	hAccelerator= LoadAccelerators(hInst, MAKEINTRESOURCE(IDR_ACCELERATOR));
	while(GetMessage(&msg, NULL, 0, 0)) {
		if(!TranslateAccelerator(hwnd, hAccelerator, &msg)) {
			if(IsDialogMessage(hwnd, &msg))
				continue;
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	DestroyAcceleratorTable(hAccelerator);
	DestroyWindow(hwnd);

	return(msg.wParam);
}

