// mjova, 26/4/96
#include <stdio.h>
#include <time.h>

#include "resource.h"


// ===============
// Defines
// ===============
#define REL_VER			"1.07"

#define DllImport	__declspec( dllimport )
#define DllExport	__declspec( dllexport )

// pojmovi za registry
#define FIRMA					"mjova"
#define PROGRAM				"LogEvent"
#define STATFILENAME			"Stat.Log"
#define STARTEDAT				"Session.Dat"

#define REG_INSTALDIR		"InstallDir"			// nema neku posebnu svrhu za sada
#define REG_TASKBARICON		"TaskbarIcon"			// da li ima ikonu u taskbaru
#define REG_IGNSHORTLOGOFF	"IgnShutDown"			// ignoriemo krai logoff
#define REG_AUTORESET		"ResetAutoDetect"		// na svakih HappyMin -10% ce simulirati ShutDown
#define REG_DIALOGPOSX		"DialogX"				// X pozicija 
#define REG_DIALOGPOSY		"DialogY"				// Y pozicija
#define REG_DATADIR			"LogFiles"				// direktorijum za podatke
#define REG_PROGRAM			"ExitProgram"			// ime programa koji e biti 
																// startovan pre izlaska iz win

#define TRAY_MSG_NOTIFYICON	(WM_APP+1)
#define LOGE_MSG_OPENDIALOG	(WM_APP+2)


#define PATH_EXIST			0
#define PATH_NOT_EXIST		1
#define ERROR_IN_PATH		2



// ===============
// Typedefs
// ===============
typedef struct _PROPERTIES {			// prop
	char szInstallDir[FILENAME_MAX];	// install dir
	char szDataDir[FILENAME_MAX];		// putanja do podataka
	char szProgram[FILENAME_MAX];		// program koji treba startovati pri izlasku
	BOOL fTrayIcon;						// da li koristimo ikonicu na taksbar-u
	int iResetAutoDetect;				// da ne pita da nastavlja seansu posle reseta
	int iHappyMin;							// logoff period koji ignoriemo
	// ovo mora na kraj strukture!
	LONG lX, lY;							// koordinate prozora
} PROPERTIES;

typedef struct _ELAPSEDDATA {			// ed
	BOOL Started;							// TRUE if Started / FALSE if loggedof
	SYSTEMTIME stStart;					// kada je startovan
	FILETIME ftStart;
	SYSTEMTIME stShutDown;				// kada je ugaen
	FILETIME ftShutDown;
	DWORD dwRunning;						// koliko je radio raunar u prethodnom periodu?
	LONG lStatFileSize;					// duina datoteke prilikom Shut Down-a
} ELAPSEDDATA;


typedef struct _TABDIALOGS {			// td
	WORD wTabId;
	char szTabName[16];
	HWND hwndCurr;
	int X, Y, cx, cy;
	DLGPROC eTabProc;
} TABDIALOGS;



// ===============
// Vriables
// ===============
extern const char *szPropertiesKeyPath;
extern PROPERTIES propCfg;
extern PROPERTIES propOrg,
						propCfgTemp;

extern HINSTANCE hInstance;
extern char szBuf[256];
extern clock_t ctStart;
extern HWND hwndPropDlg;

extern ELAPSEDDATA edRunning;
extern DWORD dwRunning;
extern BOOL bVratiMalo;

// ===============
// shared data
// ===============
extern HWND hwndMainDialog;

// ===============
// Functions
// ===============
void MakeDefaultCfg(PROPERTIES *prop);
void SaveCfg(PROPERTIES *prop);
BOOL LoadCfg(PROPERTIES *prop);
void PropertiesLogEvent(HWND hwndMain);
int CheckProperty(HWND hDlg);

void AboutLogEvent(HWND hwndMain);

int SaveStartTime(HWND hWnd);
int SaveLogout(HWND hWnd);

BOOL TrayIcon(DWORD dwMessage);

// CoreCode
BOOL CreateCompleteDir(HWND hDlg, char *szCreatePath, BOOL bCopy, const BOOL bAsk);
int DoesDirectoryExist(HWND hDlg, const char *szPathChk);
int GetFolder(HWND hDlg, char *szPath);
int GetProgram(HWND hDlg, char *szFile);


DllExport void Statistics(HWND hWnd, PROPERTIES propCfg);


