// mjova, 26/4/96

#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <stdlib.h>
#include <direct.h>
#include <commctrl.h>
#include <shlobj.h>

#include "LogEvent.h"


static BOOL bIgnore;

//----------------------------------------------------------
int SaveRegValue(HKEY hKey, LPCSTR szKeyPath, LPCSTR szKeyName, DWORD dwType, CONST BYTE *lpData, DWORD cbData)
{
	DWORD dwDisposition;
	LONG ret;
	HKEY hkPathKey;

	ret= RegOpenKeyEx(hKey, szKeyPath, (DWORD)NULL, KEY_ALL_ACCESS, &hkPathKey);	
	if(ret != ERROR_SUCCESS) { // klju nije naen, napravi ga
		ret= RegCreateKeyEx(hKey, szKeyPath, 0, NULL, REG_OPTION_NON_VOLATILE, 
							KEY_ALL_ACCESS, NULL, &hkPathKey, &dwDisposition);
		if(ret != ERROR_SUCCESS)
			return(ret);
	}
	RegSetValueEx(hkPathKey, szKeyName, (DWORD)NULL, dwType, lpData, cbData);
	RegCloseKey(hkPathKey);
	return(0);
}

//----------------------------------------------------------
int LoadRegValue(HKEY hKey, LPCSTR szKeyPath, LPCSTR szKeyName, BYTE *lpData, DWORD cbData)
{
	DWORD dwType;
	LONG ret;
	HKEY hkPathKey;

	ret= RegOpenKeyEx(hKey, szKeyPath, (DWORD)NULL, KEY_ALL_ACCESS, &hkPathKey);
	if(ret != ERROR_SUCCESS) // klju nije naen, ta u sada?!
		return(ret);
	ret= RegQueryValueEx(hkPathKey, szKeyName, 0, &dwType, lpData, &cbData);
	RegCloseKey(hkPathKey);
	return(ret);
}

//-----------------------------------------------
// popunjavanje strukture inicijalnim podacima
void MakeDefaultCfg(PROPERTIES *prop)
{
	char *p;
	RECT rect;

	if(!prop)
		return;
	// REG_INSTALDIR
	GetModuleFileName(NULL, prop->szInstallDir, sizeof(prop->szInstallDir));
	p= strrchr(prop->szInstallDir, '\\');
	if(p) *(++p)= '\0';
	// REG_DATADIR
	strcpy(prop->szDataDir, prop->szInstallDir);
	// REG_PROGRAM
	prop->szProgram[0]= '\0';
	// REG_TASKBARICON
	prop->fTrayIcon= TRUE;
	prop->iResetAutoDetect= 2;
	// REG_SHUTDOWNIDLE
	prop->iHappyMin= 10;
	// REG_DIALOGPOSX i REG_DIALOGPOSY
	if(hwndMainDialog)
		GetWindowRect(hwndMainDialog, &rect);
	else
		rect.left= rect.top= 100;
	prop->lX= rect.left;
	prop->lY= rect.top;
}

//-----------------------------------------------
void SaveCfg(PROPERTIES *prop)
{
	char buf[256];

	if(!prop)
		return;
	//----------------------------------
	// InstalDir u HKEY_LOCAL_MACHINE
	SaveRegValue(HKEY_LOCAL_MACHINE, szPropertiesKeyPath, REG_INSTALDIR, REG_SZ, 
								prop->szInstallDir, strlen(prop->szInstallDir));
	//----------------------------------
	// DataDir
	if(prop->szDataDir[strlen(prop->szDataDir)-1] == '\\')
		prop->szDataDir[strlen(prop->szDataDir)-1]= '\0';
	SaveRegValue(HKEY_CURRENT_USER, szPropertiesKeyPath, REG_DATADIR, REG_SZ, 
								prop->szDataDir, strlen(prop->szDataDir));
	//----------------------------------
	// Program
	SaveRegValue(HKEY_CURRENT_USER, szPropertiesKeyPath, REG_PROGRAM, REG_SZ, 
								prop->szProgram, strlen(prop->szProgram));
	//----------------------------------
	// da li je u upotrebi taskbar ikona 
	sprintf(buf, "%i", prop->fTrayIcon);
	SaveRegValue(HKEY_CURRENT_USER, szPropertiesKeyPath, REG_TASKBARICON, REG_SZ, 
							(BYTE *)&buf, sizeof(buf));
	//----------------------------------
	sprintf(buf, "%i", prop->iResetAutoDetect);
	SaveRegValue(HKEY_CURRENT_USER, szPropertiesKeyPath, REG_AUTORESET, REG_SZ, 
							(BYTE *)&buf, sizeof(buf));

	//----------------------------------
	// trajanje period logof-a koji e biti ignorisan
	sprintf(buf, "%i", prop->iHappyMin);
	SaveRegValue(HKEY_CURRENT_USER, szPropertiesKeyPath, REG_IGNSHORTLOGOFF, REG_SZ, 
							(BYTE *)&buf, sizeof(buf));
	//----------------------------------
	// snimanje pozicije prozora
	sprintf(buf, "%i", prop->lX);
	SaveRegValue(HKEY_CURRENT_USER, szPropertiesKeyPath, REG_DIALOGPOSX, REG_SZ, 
							(BYTE *)&buf, strlen(buf));
	sprintf(buf, "%i", prop->lY);
	SaveRegValue(HKEY_CURRENT_USER, szPropertiesKeyPath, REG_DIALOGPOSY, REG_SZ, 
							(BYTE *)&buf, strlen(buf));

	memcpy(&propOrg, prop, sizeof(propOrg));
	memcpy(&propCfg, prop, sizeof(propOrg));
	return;
}

//-----------------------------------------------
BOOL LoadCfg(PROPERTIES *prop) 
{
	LONG ret;
	BOOL fSave= FALSE;
	BYTE lpData[512];
	DWORD cbData;
	RECT rect;
	LONG lX, lY;

	if(!prop)
		return(0);
	// gde je LogEvenet trenutno?
	cbData= sizeof(lpData);
	ret= LoadRegValue(HKEY_LOCAL_MACHINE, szPropertiesKeyPath, REG_INSTALDIR, lpData, cbData);
	if(ret == ERROR_SUCCESS)
		strcpy(prop->szInstallDir, lpData);
	else
		fSave= TRUE;

	// kamo se uvaju podaci
	cbData= sizeof(lpData);
	ret= LoadRegValue(HKEY_CURRENT_USER, szPropertiesKeyPath, REG_DATADIR, lpData, cbData);
	if(ret == ERROR_SUCCESS) {
		strcpy(prop->szDataDir, lpData);
		if(prop->szDataDir[strlen(prop->szDataDir)-1] == '\\')
			prop->szDataDir[strlen(prop->szDataDir)-1]= '\0';
	} else
		fSave= TRUE;

	// koji program startovati pri izlasku iz LogEvent-a
	cbData= sizeof(lpData);
	ret= LoadRegValue(HKEY_CURRENT_USER, szPropertiesKeyPath, REG_PROGRAM, lpData, cbData);
	if(ret == ERROR_SUCCESS)	strcpy(prop->szProgram, lpData);
	else								fSave= TRUE;

	// da li treba prikazati ikonicu u taskbar-u
	cbData= sizeof(lpData);
	ret= LoadRegValue(HKEY_CURRENT_USER, szPropertiesKeyPath, REG_TASKBARICON, lpData, cbData);
	if(ret == ERROR_SUCCESS)	prop->fTrayIcon= atoi(lpData)?1:0;
	else								fSave= TRUE;

	// 
	cbData= sizeof(lpData);
	ret= LoadRegValue(HKEY_CURRENT_USER, szPropertiesKeyPath, REG_AUTORESET, lpData, cbData);
	if(ret == ERROR_SUCCESS)	prop->iResetAutoDetect= min(abs(atoi(lpData)), 2);
	else								fSave= TRUE;

	// sd.,faslfgmladflgmsdlfgmsdflgmsdf
	cbData= sizeof(lpData);
	ret= LoadRegValue(HKEY_CURRENT_USER, szPropertiesKeyPath, REG_IGNSHORTLOGOFF, lpData, cbData);
	if(ret == ERROR_SUCCESS)	prop->iHappyMin= min(abs(atoi(lpData)), 20);
	else								fSave= TRUE;

	GetWindowRect(hwndMainDialog, &rect);
	ret= LoadRegValue(HKEY_CURRENT_USER, szPropertiesKeyPath, REG_DIALOGPOSX, lpData, cbData);
	if(ret == ERROR_SUCCESS) {
		lX= atoi(lpData);
		ret= LoadRegValue(HKEY_CURRENT_USER, szPropertiesKeyPath, REG_DIALOGPOSY, lpData, cbData);
		if(ret == ERROR_SUCCESS) {
			lY= atoi(lpData);
			prop->lX= lX;
			prop->lY= lY;
		}
	}
	if(ret != ERROR_SUCCESS) {
		prop->lX= rect.left;
		prop->lY= rect.top;
		fSave= TRUE;
	}
	return(fSave);
}



//-------------------------------------------------------
int CheckProperty(HWND hDlg)
{
	if(memcmp(&propOrg, &propCfg, sizeof(PROPERTIES) - 2*sizeof(LONG))) {
		int ret;
		ret= MessageBox(hDlg, "You have changed property - do you want to save it?", 
								"Just a minute!",  MB_ICONQUESTION|MB_YESNO);
		if(ret == IDYES)
			SaveCfg(&propCfg);
	}
	return(0);
}


//-------------------------------------------------------
int InitTab(HWND hTab)
{
	TABDIALOGS *td; 

	td= (TABDIALOGS *)GetWindowLong(GetParent(hTab), GWL_USERDATA); 
	SetWindowPos(hTab, HWND_TOP, td[0].X, td[0].Y, td[0].cx, td[0].cy, SWP_SHOWWINDOW);
	return(0);
}

//-------------------------------------------------------
BOOL CALLBACK eTabGenProc(HWND hTab, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg) {
		case WM_INITDIALOG: 
			bIgnore= TRUE;
			InitTab(hTab);
			SendDlgItemMessage(hTab, IDC_TRAYICON, BM_SETCHECK, propCfgTemp.fTrayIcon, 0);
			switch(propCfgTemp.iResetAutoDetect) {
				case 0:
					SendDlgItemMessage(hTab, IDC_AUTORESET, BM_SETCHECK, BST_UNCHECKED, 0);
					SetDlgItemText(hTab, IDC_AUTORESET, "No");
					break;
				case 1:
					SendDlgItemMessage(hTab, IDC_AUTORESET, BM_SETCHECK, BST_CHECKED, 0);
					SetDlgItemText(hTab, IDC_AUTORESET, "Yes");
					break;
				case 2:
					SendDlgItemMessage(hTab, IDC_AUTORESET, BM_SETCHECK, BST_INDETERMINATE, 0);
					SetDlgItemText(hTab, IDC_AUTORESET, "Maybe");
					break;
			}

			SendDlgItemMessage(hTab, IDC_EDIT_MIN, EM_SETLIMITTEXT, 2, 0);
			SendDlgItemMessage(hTab, IDC_SPIN_MIN, UDM_SETBUDDY, (WPARAM)GetDlgItem(hTab, IDC_EDIT_MIN), 0);
			SendDlgItemMessage(hTab, IDC_SPIN_MIN, UDM_SETPOS, 0, (LPARAM)MAKELONG((short)propCfgTemp.iHappyMin, 0));
			SendDlgItemMessage(hTab, IDC_SPIN_MIN, UDM_SETRANGE, 0, (LPARAM)MAKELONG((short)20, (short)0));
			
			SetDlgItemInt(hTab, IDC_EDIT_MIN, propCfgTemp.iHappyMin, FALSE);
			bIgnore= FALSE;
			break;

		case WM_COMMAND:
			switch(GET_WM_COMMAND_ID(wParam, lParam)) {
				case IDC_TRAYICON:
					propCfgTemp.fTrayIcon= (BST_CHECKED == SendDlgItemMessage(hTab, IDC_TRAYICON, BM_GETCHECK, 0, 0));
					if(bIgnore)
						break;
					EnableWindow(GetDlgItem(GetParent(hTab), ID_APLAY), TRUE);
					break;
				case IDC_AUTORESET:
					switch(SendDlgItemMessage(hTab, IDC_AUTORESET, BM_GETCHECK, 0, 0)) {
						case BST_UNCHECKED:
							propCfgTemp.iResetAutoDetect= 0;
							SetDlgItemText(hTab, IDC_AUTORESET, "No");
							break;
						case BST_CHECKED:
							propCfgTemp.iResetAutoDetect= 1;
							SetDlgItemText(hTab, IDC_AUTORESET, "Yes");
							break;
						case BST_INDETERMINATE:
							propCfgTemp.iResetAutoDetect= 2;
							SetDlgItemText(hTab, IDC_AUTORESET, "Maybe");
							break;
					}
					if(bIgnore)
						break;
					EnableWindow(GetDlgItem(GetParent(hTab), ID_APLAY), TRUE);
					break;
				case IDC_EDIT_MIN:		// ovo je od edit kontrole za iHappyMin
					switch(GET_WM_COMMAND_CMD(wParam, lParam)) {
						case EN_KILLFOCUS:
							propCfgTemp.iHappyMin= GetDlgItemInt(hTab, IDC_EDIT_MIN, NULL, FALSE);
							break;
						case EN_CHANGE:
							if(bIgnore)
								break;
							EnableWindow(GetDlgItem(GetParent(hTab), ID_APLAY), TRUE);
							EnableWindow(GetDlgItem(GetParent(hTab), IDOK), TRUE);
							if(GET_WM_COMMAND_ID(wParam, lParam) == IDC_EDIT_MIN)
								propCfgTemp.iHappyMin= GetDlgItemInt(hTab, IDC_EDIT_MIN, NULL, FALSE);
							break;
					}
					break;
			}
			break;

/*		case WM_DESTROY:
			propCfgTemp.iHappyMin= GetDlgItemInt(hTab, IDC_EDIT_MIN, NULL, FALSE);
			propCfgTemp.iSafeReset= GetDlgItemInt(hTab, IDC_EDIT_MIN_SR, NULL, FALSE);
			break;
*/
		default:
			return (FALSE);
	}
	return(TRUE);
}

//-------------------------------------------------------
BOOL CALLBACK eTabDataProc(HWND hTab, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg) {
		case WM_INITDIALOG: 
			bIgnore= TRUE;
			InitTab(hTab);
			SetDlgItemText(hTab, IDC_DATADIR, propCfgTemp.szDataDir);
			bIgnore= FALSE;
			break;
		case WM_COMMAND:
			switch(GET_WM_COMMAND_ID(wParam, lParam)) {
				case IDC_DATADIR:			// ovo je od edit kontrole DataDir
					switch(GET_WM_COMMAND_CMD(wParam, lParam)) {
						case EN_KILLFOCUS:
							GetDlgItemText(hTab, IDC_DATADIR, propCfgTemp.szDataDir, sizeof(propCfgTemp.szDataDir));
							break;
						case EN_CHANGE:
							if(bIgnore)
								break;
							EnableWindow(GetDlgItem(GetParent(hTab), ID_APLAY), TRUE);
							EnableWindow(GetDlgItem(GetParent(hTab), IDOK), TRUE);
							break;
					}
					break;
				case IDBROWSE_FOLDER:	// button za DataDir
					if(GetFolder(hTab, propCfgTemp.szDataDir))
						break;
					SetDlgItemText(hTab, IDC_DATADIR, propCfgTemp.szDataDir);
					break;
			}
			break;
/*		case WM_DESTROY:
			GetDlgItemText(hTab, IDC_DATADIR, propCfgTemp.szDataDir, sizeof(propCfgTemp.szDataDir));
			break;
*/
		default:
			return (FALSE);
	}
	return(TRUE);
}

//-------------------------------------------------------
BOOL CALLBACK eTabExitProc(HWND hTab, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg) {
		case WM_INITDIALOG:	
			bIgnore= TRUE;
			InitTab(hTab);
			SetDlgItemText(hTab, IDC_PROGRAM, propCfgTemp.szProgram);
			bIgnore= FALSE;
			break;

		case WM_COMMAND:
			switch(GET_WM_COMMAND_ID(wParam, lParam)) {
				case IDC_PROGRAM:			// ovo je od edit kontrole Program
					switch(GET_WM_COMMAND_CMD(wParam, lParam)) {
						case EN_KILLFOCUS:
							GetDlgItemText(hTab, IDC_PROGRAM, propCfgTemp.szProgram, sizeof(propCfgTemp.szProgram));
							break;
						case EN_CHANGE:
							if(bIgnore)
								break;
							EnableWindow(GetDlgItem(GetParent(hTab), ID_APLAY), TRUE);
							EnableWindow(GetDlgItem(GetParent(hTab), IDOK), TRUE);
							break;
					}
					break;
				case IDBROWSE_PROGRAM:
					if(GetProgram(hTab, propCfgTemp.szProgram))
						break;
					SetDlgItemText(hTab, IDC_PROGRAM, propCfgTemp.szProgram);
					EnableWindow(GetDlgItem (GetParent(hTab), ID_APLAY), TRUE);
					break;
			}
			break;

/*		case WM_DESTROY:
			GetDlgItemText(hTab, IDC_PROGRAM, propCfgTemp.szProgram, sizeof(propCfgTemp.szProgram));
			break;
*/
		default:
			return (FALSE);
	}
	return(TRUE);
}

//-------------------------------------------------------
int MakeTabControl(HWND hDlg) 
{
	HWND hwndTab;
	RECT rcDlg, rcTab, rcTabCli;
	int i;
	TC_ITEM tci;
	TABDIALOGS *td;

	td= (TABDIALOGS *)LocalAlloc(LPTR, 3*sizeof(TABDIALOGS));
	SetWindowLong(hDlg, GWL_USERDATA, (LONG)td);

	hwndTab= GetDlgItem(hDlg, IDC_TAB);

	strcpy(td[0].szTabName, "General");
	td[0].wTabId= IDD_PROP_GEN;
	td[0].eTabProc= eTabGenProc;
	strcpy(td[1].szTabName, "Data");
	td[1].wTabId= IDD_PROP_DATA;
	td[1].eTabProc= eTabDataProc;
	strcpy(td[2].szTabName, "Exiting");
	td[2].wTabId= IDD_PROP_EXIT;
	td[2].eTabProc= eTabExitProc;

	GetWindowRect(hwndTab, &rcTab);

	tci.mask= TCIF_TEXT | TCIF_IMAGE;
	tci.iImage= -1;
	for(i= 2; i>=0; i--) {
		tci.pszText= td[i].szTabName;
		TabCtrl_InsertItem(hwndTab, 0, &tci);
	}
	GetWindowRect(hDlg, &rcDlg);
	GetWindowRect(hwndTab, &rcTab);
	GetWindowRect(hwndTab, &rcTabCli);
	TabCtrl_AdjustRect(hwndTab, TRUE, &rcTab);
	TabCtrl_AdjustRect(hwndTab, FALSE, &rcTabCli);
	td[0].X= rcTabCli.left - rcDlg.left - GetSystemMetrics(SM_CXSIZEFRAME)/2;
	td[0].Y= rcTabCli.top - rcDlg.top - GetSystemMetrics(SM_CYCAPTION) - GetSystemMetrics(SM_CYSIZEFRAME)/2;
	td[0].cx= rcTabCli.right - rcTabCli.left;
	td[0].cy= rcTabCli.bottom - rcTabCli.top;

	TabCtrl_SetCurSel(GetDlgItem(hDlg, IDC_TAB), 0);
	td[0].hwndCurr= CreateDialog(hInstance, MAKEINTRESOURCE(td[0].wTabId), hDlg, td[0].eTabProc);
	return(0);
}

//-------------------------------------------------------
BOOL CALLBACK ePropertiesLogEvent(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg) {
		case WM_INITDIALOG: 
			memcpy(&propCfgTemp, &propCfg, sizeof(PROPERTIES));
			MakeTabControl(hDlg);
			EnableWindow(GetDlgItem(hDlg, ID_APLAY), FALSE);
			hwndPropDlg= hDlg;
			break;

		case WM_DESTROY:
			hwndPropDlg= NULL;
			break;

		case WM_NOTIFY:
			if(((LPNMHDR)lParam)->code == TCN_SELCHANGE) {
				TABDIALOGS *td;
				int iSel;
				
				td= (TABDIALOGS *)GetWindowLong(hDlg, GWL_USERDATA);
				iSel= TabCtrl_GetCurSel(GetDlgItem(hDlg, IDC_TAB));

				if(td[0].hwndCurr) 
					DestroyWindow(td[0].hwndCurr); 
				td[0].hwndCurr= CreateDialog(hInstance, MAKEINTRESOURCE(td[iSel].wTabId), hDlg, td[iSel].eTabProc);
			}
			break;

		case WM_COMMAND:
			switch(GET_WM_COMMAND_ID(wParam, lParam)) {
				case IDOK:
					SendMessage(hDlg, WM_COMMAND, ID_APLAY, 0);
					SendMessage(hDlg, WM_COMMAND, IDCANCEL, 0);
					break;
				case IDCANCEL: {
						TABDIALOGS *td;
						td= (TABDIALOGS *)GetWindowLong(hDlg, GWL_USERDATA);
						if(td[0].hwndCurr) 
							DestroyWindow(td[0].hwndCurr); 
						EndDialog(hDlg, 0);
					}
					break;
				case ID_APLAY: {
						TABDIALOGS *td;
						// int iSel;
						
						td= (TABDIALOGS *)GetWindowLong(hDlg, GWL_USERDATA);
						// iSel= TabCtrl_GetCurSel(GetDlgItem(hDlg, IDC_TAB));
						SendMessage(td[0].hwndCurr, WM_KILLFOCUS, 0, 0); 

						if(DoesDirectoryExist(hDlg, propCfgTemp.szDataDir) != PATH_EXIST) {
							// dir ne postji
							EnableWindow(GetDlgItem(hDlg, IDOK), FALSE);
							TabCtrl_SetCurSel(GetDlgItem(hDlg, IDC_TAB), 1);
							if(td[0].hwndCurr) 
								DestroyWindow(td[0].hwndCurr); 
							td[0].hwndCurr= CreateDialog(hInstance, MAKEINTRESOURCE(td[1].wTabId), hDlg, td[1].eTabProc);
							if(CreateCompleteDir(hDlg, propCfgTemp.szDataDir, TRUE, TRUE))
								return (FALSE);
						}
					}
					SaveCfg(&propCfgTemp);
					TrayIcon(propCfg.fTrayIcon ? NIM_ADD : NIM_DELETE);
					EnableWindow(GetDlgItem(hDlg, ID_APLAY), FALSE);	
					EnableWindow(GetDlgItem(hDlg, IDOK), TRUE);
					break;

				default:
					return(FALSE);
			}
			break;

		default:
			return (FALSE);
	}
	return(TRUE);
}

//-------------------------------------------------------
void PropertiesLogEvent(HWND hwndMain)
{
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_PROP), hwndMain, ePropertiesLogEvent);
	SendDlgItemMessage(hwndMain, IDC_TRAYICON, BM_SETCHECK, propCfg.fTrayIcon, 0);
}

