// mjova, 26/4/96

	// ----------------------
	// na biciklu vozim Nenu
	// ulice pune se rupama
	// preivjelih nema drue
	// ulice pune su rtava
	// ----------------------

#include <windowsx.h>
#include <windows.h>
#include <stdio.h>
#include <time.h>
#include <commctrl.h>

#include "resource.h"
#include "LogEvent.h"

//---------------------------------------------------------------------------
int LoadRunning(HWND hWnd) {
	char szRunningFileName[256];
	HANDLE hRunning;
	DWORD dwNum;
	BOOL b;
	int ret= 0;

	sprintf(szRunningFileName, "%s\\" STARTEDAT, propCfg.szDataDir);
	hRunning= CreateFile(szRunningFileName, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
	if(hRunning == INVALID_HANDLE_VALUE) {
		// ne postoji direktorijum (ili je ko zna ta...)
		// sprintf(szBuf, "Cannot open file:\n%s", szRunningFileName);
		// MessageBox(hWnd, szBuf, "LogEvent", MB_ICONEXCLAMATION|MB_OK);
		return(-1);		// nema datoteke
	}
	b= ReadFile(hRunning, &edRunning, sizeof(edRunning), &dwNum, NULL);
	if(!b || dwNum!=sizeof(edRunning))
		ret= -1;			// ne valja fajl
	CloseHandle(hRunning);
	return(ret);
}

//---------------------------------------------------------------------------
int SaveRunning(HWND hWnd, BOOL bForceSave) {
	char szRunningFileName[256];
	HANDLE hRunning;
	DWORD dwNum;
	int ret= 0;

	sprintf(szRunningFileName, "%s\\" STARTEDAT, propCfg.szDataDir);
	hRunning= CreateFile(szRunningFileName, GENERIC_WRITE, 0, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, 0);
	if(hRunning == INVALID_HANDLE_VALUE) {
		// ili datoteka postoji ili ne postoji direktorijum
		hRunning= CreateFile(szRunningFileName, GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
		if(hRunning == INVALID_HANDLE_VALUE) {
			// ne postoji direktorijum (ili je ko zna ta...)
			sprintf(szBuf, "Cannot open file:\n%s", szRunningFileName);
			MessageBox(hWnd, szBuf, "LogEvent", MB_ICONEXCLAMATION|MB_OK);
			return(-1);		// nema datoteke niti se moe napraviti
		} else {
			// datoteka je kreirana
			if(bForceSave)
				WriteFile(hRunning, &edRunning, sizeof(edRunning), &dwNum, NULL);
		}
	} else {
		// upisujemo vreme startovanja samo ako daoteka ne postoji
		WriteFile(hRunning, &edRunning, sizeof(edRunning), &dwNum, NULL);
	}

	CloseHandle(hRunning);
	return(ret);
}

//---------------------------------------------------------------------------
// vraa razliku u minutama
int SubFileTime(FILETIME *ftA, FILETIME *ftB) {
	// __int64 se moze koristiti kao tip promenljive.
	// potpuno je ravnopravan sa ostalim tipovima, ali
	// treba voditi rauna da je on specifian za MSC
	// u sprintf() se koristiti umesto %d/%i %i64.
	__int64 A, B;

	A=		ftA->dwHighDateTime;
	A<<=	32;
	A+=	ftA->dwLowDateTime;
	B=		ftB->dwHighDateTime;
	B<<=	32;
	B+=	ftB->dwLowDateTime;

	A-= B;
	A/= 600000000L;

	return((int)A);
}

//---------------------------------------------------------------------------
// hWnd nam sutinski ne treba, ali time se obezbeujemo da e 
// konfiguracija biti uitana.
// poziva se neposredno po startovanju programa
int SaveStartTime(HWND hWnd)
{
	FILETIME ftNow;
	SYSTEMTIME st;
	int iRes;

	GetLocalTime(&st);
	SystemTimeToFileTime(&st, &ftNow);

	// prvo da pokupimo podatke iz datoteke
	if(!LoadRunning(hWnd)) {
		// ima datoteke, proveriti da li je razlika vremena 
		// manja od prop->HappyMin
		dwRunning= edRunning.dwRunning;
		if(edRunning.Started && propCfg.iResetAutoDetect) {	// resetovan raunar
			int ret;

			ret= propCfg.iResetAutoDetect==1 ? IDYES :
									MessageBox(hWnd, "Continue last session?", "LogEvent - Reset detected!", 
															MB_ICONQUESTION|MB_YESNO|MB_SYSTEMMODAL);
			bVratiMalo= FALSE;	// nita u log nije upisano, te nije potrebno vraati..
			if(ret == IDYES) {
				iRes= SubFileTime(&ftNow, &edRunning.ftStart);
				dwRunning= iRes*60;
				return(0);
			}
		} else {
			edRunning.Started= TRUE;
			iRes= SubFileTime(&ftNow, &edRunning.ftShutDown);
			if(iRes < propCfg.iHappyMin) {
				// menjamo samo podatak da se sesija nastavlja
				bVratiMalo= TRUE;		// vraamo
				if(SaveRunning(hWnd, TRUE))
					return(-1);
				return(0);
			}
		}
	} else {
		bVratiMalo= FALSE;
		memset(&edRunning, 0, sizeof(edRunning));
		edRunning.Started= TRUE;
	}

	dwRunning= edRunning.dwRunning= 0;
	GetLocalTime(&edRunning.stStart);
	SystemTimeToFileTime(&edRunning.stStart, &edRunning.ftStart);
	if(SaveRunning(hWnd, TRUE))
		return(-1);
	return(0);
}


//---------------------------------------------------------------------------
// poziva se pri izlasku iz Win! (WM_ENDSESSION)
int SaveLogout(HWND hWnd)
{
	char szStatFileName[256];
	HANDLE hStatFile;
	DWORD dwNum;
	char szTemp[128];
	char szLine[256];
	int iH, iM, iS;
	clock_t ctEnd;
	long lFilePos;

	ctEnd= clock();
	GetLocalTime(&edRunning.stShutDown);
	SystemTimeToFileTime(&edRunning.stShutDown, &edRunning.ftShutDown);
	edRunning.dwRunning += 	(ctEnd-ctStart)/CLOCKS_PER_SEC;

	sprintf(szStatFileName, "%s\\" STATFILENAME, propCfg.szDataDir);
	hStatFile= CreateFile(szStatFileName, GENERIC_WRITE, 0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
	if(hStatFile == INVALID_HANDLE_VALUE) {
		// ne postoji direktorijum (ili je ko zna ta...)
		sprintf(szBuf, "Cannot open file:\n%s", szStatFileName);
		MessageBox(hWnd, szBuf, "LogEvent", MB_ICONEXCLAMATION|MB_OK);
		return(-1);		// nema datoteke niti se moe napraviti
	}

	GetDateFormat(LOCALE_USER_DEFAULT, 0, &edRunning.stStart, "dd'/'MM'/'yyyy ddd ", szTemp, sizeof(szTemp));
	strcpy(szLine, szTemp);
	GetTimeFormat(LOCALE_USER_DEFAULT, 0, &edRunning.stStart, "HH':'mm ", szTemp, sizeof(szTemp));
	strcat(szLine, szTemp);

	iS= edRunning.dwRunning%60;
	iM= (edRunning.dwRunning/60)%60;
	iH= (edRunning.dwRunning/60)/60;
	sprintf(szTemp, "%03i:%02i:%02i\r\n", iH, iM, iS);
	strcat(szLine, szTemp);

	lFilePos= bVratiMalo ? strlen(szLine) : 0;
	SetFilePointer(hStatFile, -lFilePos, NULL, FILE_END);

	WriteFile(hStatFile, szLine, strlen(szLine), &dwNum, NULL);
	CloseHandle(hStatFile);

	edRunning.Started= FALSE;
	if(SaveRunning(hWnd, TRUE))
		return(-1);
	return(0);
}

	  ///////////////////////////////////////////////////
	 // zar si stvarno mislila da je sve to igra	     //
   //  to sam ja zbog tebe sam						    //
  //   a to e sada kad si stigla do zida		   //
 //    a doma nema goluba da te miluje				  //
///////////////////////////////////////////////////
